/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include "config.h"

//

#include "_chatmodelconfig.h"
#include "jsoncpp/json/json.h"

ChatModelConfig *chat_model_config_create() { return new _ChatModelConfig(); }

void chat_model_config_destroy(ChatModelConfig **config) {
    if (config == nullptr) {
        return;
    }
    delete *config;
    *config = nullptr;
}

void chat_model_config_set_name(ChatModelConfig *config, const char *name) {
    if (config == nullptr) {
        return;
    }
    config->name_ = name;
}
void chat_model_config_set_top_k(ChatModelConfig *config, int top_k) {
    if (config == nullptr) {
        return;
    }
    config->topK_ = top_k;
}
void chat_model_config_set_deploy_type(ChatModelConfig *config,
                                       ModelDeployType type) {
    if (config == nullptr) {
        return;
    }
    config->type_ = type;
}

Json::Value modelConfigToJson(const _ChatModelConfig &modelConfig) {
    Json::Value root;
    root["model_name"] = modelConfig.name_;
    root["deploy_type"] = getModelConfigType(modelConfig);
    root["top_k"] = modelConfig.topK_;
    return root;
}

std::string getModelConfigType(const _ChatModelConfig &modelConfig) {
    switch (modelConfig.type_) {
        case ModelDeployType::OnDevice:
            return "Local";
        case ModelDeployType::Custom:
            return "Custom";
        case ModelDeployType::PublicCloud:
            return "PublicCloud";
        default:
            return "Default";
    }
}
